import 'dart:convert';
import 'dart:typed_data';

import './reader_seeker.dart';
class ImageSectionHeader {

  List<int> _name = List.filled(8, 0);

  String name = "";
  
  int misc = 0;
  
  int virtualAddress = 0;

  int sizeOfRawData = 0;
  
  int pointerToRawData = 0;

  int pointerToRelocations = 0;

  int pointerToLinenumbers = 0;

  int numberOfRelocations = 0;

  int numberOfLinenumbers = 0;

  int characteristics = 0;

  ImageSectionHeader(ReaderSeeker readerSeeker){
    _name = readerSeeker.getByte(8);
    name = utf8.decode(_name,allowMalformed: true);
    var data = readerSeeker.getData(32);
    misc = data.getUint32(0,Endian.little);
    virtualAddress = data.getUint32(4,Endian.little);
    sizeOfRawData = data.getUint32(8,Endian.little);
    pointerToRawData = data.getUint32(12,Endian.little);
    pointerToRelocations = data.getUint32(16,Endian.little);
    pointerToLinenumbers = data.getUint32(20,Endian.little);
    numberOfRelocations = data.getUint16(24,Endian.little);
    numberOfLinenumbers = data.getUint16(26,Endian.little);
    characteristics = data.getUint32(28,Endian.little);
  }

  @override
  String toString(){
    return '{"name":"${name}", "_name": "${_name}", "misc":${misc.toRadixString(16)}, "virtualAddress":${virtualAddress.toRadixString(16)}, "sizeOfRawData":${sizeOfRawData.toRadixString(16)}, "pointerToRawData":${pointerToRawData.toRadixString(16)}, "pointerToRelocations":${pointerToRelocations.toRadixString(16)}, "pointerToLinenumbers":${pointerToLinenumbers.toRadixString(16)}, "numberOfRelocations":${numberOfRelocations.toRadixString(16)}, "numberOfLinenumbers":${numberOfLinenumbers.toRadixString(16)}, "characteristics":${characteristics.toRadixString(16)}}';
  }

}